#!/bin/sh

# This is the cheap, interactive installation script for mpg123-mysql
# for the novices :)

# Version 0.01 dominik@brettnacher.org
# - initial try :)

VERSION=0.7
MPG123_VERSION="mpg123-0.59r"

MPG123="$MPG123_VERSION.tar.gz"

until [ -e $MPG123 ]
do
    echo "Where can I find your mpg123 distribution [$MPG123_VERSION.tar.gz]?"
    read MPG123;
    echo
done

echo -n "trying to untar $MPG123..."
(gzip -cd $MPG123 |tar xf -) && echo "done"

echo -n "applying mpg123-mysql patches..."
(cd $MPG123_VERSION; patch < ../mpg123-mysql-$VERSION.patch 2>patch.log) && echo "done"

echo
echo "now please give me some information about your MySQL database:"
until [ $MYSQL_HOST ]
do
    echo -n " 1. Your MySQL server host (e.g. \"localhost\"): "
    read MYSQL_HOST
done

until [ $MYSQL_USER ]
do
    echo -n " 2. Your MySQL user name (e.g. \"`whoami`\"): "
    read MYSQL_USER
done

until [ $MYSQL_PASSWORD ]
do
    echo -n " 3. Your MySQL password for $MYSQL_USER: "
    read MYSQL_PASSWORD
done

until [ $MYSQL_DB ]
do
    echo -n " 4. The database that mpg123-mysql should use (e.g. \"mp3\"): "
    read MYSQL_DB
done

echo "#define MYSQL_HOST	\"$MYSQL_HOST\"" >>$MPG123_VERSION/mysqlconfig.h
echo "#define MYSQL_USER	\"$MYSQL_USER\"" >>$MPG123_VERSION/mysqlconfig.h
echo "#define MYSQL_PASSWORD	\"$MYSQL_PASSWORD\"" >>$MPG123_VERSION/mysqlconfig.h
echo "#define MYSQL_DB	\"$MYSQL_DB\"" >>$MPG123_VERSION/mysqlconfig.h

echo -n "Shall I use \"mysql\" to create the database [Y/n]? "
read ANSWER
case $ANSWER in
[Nn])
	;;
*)
	echo "Trying to create database $MYSQL_DB. I hope I'm allowed to do so."
	mysqladmin -h $MYSQL_HOST -u $MYSQL_USER -p$MYSQL_PASSWORD create $MYSQL_DB
	;;
esac

echo -n "Shall I create the table for mpg123-mysql using \"mysql\" [Y/n]? "
read ANSWER
case $ANSWER in
[Nn])
	;;
*)
	echo "Trying to create table mp3 in $MYSQL_DB. I hope I'm allowed to do so."
	mysql -h $MYSQL_HOST -u $MYSQL_USER -p$MYSQL_PASSWORD $MYSQL_DB <createtable.sql
	;;
esac

echo
echo "Now I have finished. All you have to do now is:"
echo " 1. Compile mpg123:"
echo "     cd $MPG123_VERSION"
echo "     make <your-system> (\"make\" for help)"
echo " 2. Install mpg123:"
echo "     make install"
echo " 3. Insert your files into the database (e.g. using insertfiles.pl)."
echo " 4. Play around with mpg123-mysql."
